
-- try to get a script context, will be .nil, if script was not invoked by OOo
x_ScriptContext = uno.getScriptContext()
if (x_ScriptContext <> .nil) then   -- invoked by OOo as a macro
do
   componentContext = x_ScriptContext~getComponentContext   -- get context
   desktop  = x_ScriptContext~getDesktop  -- get desktop (an XDesktop)
   document = x_ScriptContext~getDocument -- get current document
end
else  -- called from outside of OOo, create a connection
do
   -- connect to Open Office
--   me~ComponentContext = UNO.connect(unourl);
   componentContext = UNO.connect()       -- connect & get component context

   -- create a desktop object
   s="com.sun.star.frame.Desktop"
   d= componentContext~getServiceManager~XMultiServiceFactory~createInstance(s)
   desktop=d~XDesktop                     -- query XDestkop interface

   -- get current document
   me~Document = me~Desktop~getCurrentComponent()

end

return me

::requires UNO.CLS

::class MacroEnvironment
::method ComponentContext attribute
::method Desktop attribute
::method Document attribute
